//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: provenance/attribute/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for attribute module.
///
/// Usage: instantiate `Provenance_Attribute_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Provenance_Attribute_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Provenance_Attribute_V1_QueryClientInterceptorFactoryProtocol? { get }

  func params(
    _ request: Provenance_Attribute_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Provenance_Attribute_V1_QueryParamsRequest, Provenance_Attribute_V1_QueryParamsResponse>

  func attribute(
    _ request: Provenance_Attribute_V1_QueryAttributeRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Provenance_Attribute_V1_QueryAttributeRequest, Provenance_Attribute_V1_QueryAttributeResponse>

  func attributes(
    _ request: Provenance_Attribute_V1_QueryAttributesRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Provenance_Attribute_V1_QueryAttributesRequest, Provenance_Attribute_V1_QueryAttributesResponse>

  func scan(
    _ request: Provenance_Attribute_V1_QueryScanRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Provenance_Attribute_V1_QueryScanRequest, Provenance_Attribute_V1_QueryScanResponse>
}

extension Provenance_Attribute_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "provenance.attribute.v1.Query"
  }

  /// Params queries params of the attribute module.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Provenance_Attribute_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Provenance_Attribute_V1_QueryParamsRequest, Provenance_Attribute_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/provenance.attribute.v1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }

  /// Attribute queries attributes on a given account (address) for one (or more) with the given name
  ///
  /// - Parameters:
  ///   - request: Request to send to Attribute.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func attribute(
    _ request: Provenance_Attribute_V1_QueryAttributeRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Provenance_Attribute_V1_QueryAttributeRequest, Provenance_Attribute_V1_QueryAttributeResponse> {
    return self.makeUnaryCall(
      path: "/provenance.attribute.v1.Query/Attribute",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAttributeInterceptors() ?? []
    )
  }

  /// Attributes queries attributes on a given account (address) for any defined attributes
  ///
  /// - Parameters:
  ///   - request: Request to send to Attributes.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func attributes(
    _ request: Provenance_Attribute_V1_QueryAttributesRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Provenance_Attribute_V1_QueryAttributesRequest, Provenance_Attribute_V1_QueryAttributesResponse> {
    return self.makeUnaryCall(
      path: "/provenance.attribute.v1.Query/Attributes",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAttributesInterceptors() ?? []
    )
  }

  /// Scan queries attributes on a given account (address) for any that match the provided suffix
  ///
  /// - Parameters:
  ///   - request: Request to send to Scan.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func scan(
    _ request: Provenance_Attribute_V1_QueryScanRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Provenance_Attribute_V1_QueryScanRequest, Provenance_Attribute_V1_QueryScanResponse> {
    return self.makeUnaryCall(
      path: "/provenance.attribute.v1.Query/Scan",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeScanInterceptors() ?? []
    )
  }
}

internal protocol Provenance_Attribute_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Provenance_Attribute_V1_QueryParamsRequest, Provenance_Attribute_V1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when invoking 'attribute'.
  func makeAttributeInterceptors() -> [ClientInterceptor<Provenance_Attribute_V1_QueryAttributeRequest, Provenance_Attribute_V1_QueryAttributeResponse>]

  /// - Returns: Interceptors to use when invoking 'attributes'.
  func makeAttributesInterceptors() -> [ClientInterceptor<Provenance_Attribute_V1_QueryAttributesRequest, Provenance_Attribute_V1_QueryAttributesResponse>]

  /// - Returns: Interceptors to use when invoking 'scan'.
  func makeScanInterceptors() -> [ClientInterceptor<Provenance_Attribute_V1_QueryScanRequest, Provenance_Attribute_V1_QueryScanResponse>]
}

internal final class Provenance_Attribute_V1_QueryClient: Provenance_Attribute_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Provenance_Attribute_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the provenance.attribute.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Provenance_Attribute_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for attribute module.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Provenance_Attribute_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Provenance_Attribute_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// Params queries params of the attribute module.
  func params(request: Provenance_Attribute_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Provenance_Attribute_V1_QueryParamsResponse>

  /// Attribute queries attributes on a given account (address) for one (or more) with the given name
  func attribute(request: Provenance_Attribute_V1_QueryAttributeRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Provenance_Attribute_V1_QueryAttributeResponse>

  /// Attributes queries attributes on a given account (address) for any defined attributes
  func attributes(request: Provenance_Attribute_V1_QueryAttributesRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Provenance_Attribute_V1_QueryAttributesResponse>

  /// Scan queries attributes on a given account (address) for any that match the provided suffix
  func scan(request: Provenance_Attribute_V1_QueryScanRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Provenance_Attribute_V1_QueryScanResponse>
}

extension Provenance_Attribute_V1_QueryProvider {
  internal var serviceName: Substring { return "provenance.attribute.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Provenance_Attribute_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Provenance_Attribute_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    case "Attribute":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Provenance_Attribute_V1_QueryAttributeRequest>(),
        responseSerializer: ProtobufSerializer<Provenance_Attribute_V1_QueryAttributeResponse>(),
        interceptors: self.interceptors?.makeAttributeInterceptors() ?? [],
        userFunction: self.attribute(request:context:)
      )

    case "Attributes":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Provenance_Attribute_V1_QueryAttributesRequest>(),
        responseSerializer: ProtobufSerializer<Provenance_Attribute_V1_QueryAttributesResponse>(),
        interceptors: self.interceptors?.makeAttributesInterceptors() ?? [],
        userFunction: self.attributes(request:context:)
      )

    case "Scan":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Provenance_Attribute_V1_QueryScanRequest>(),
        responseSerializer: ProtobufSerializer<Provenance_Attribute_V1_QueryScanResponse>(),
        interceptors: self.interceptors?.makeScanInterceptors() ?? [],
        userFunction: self.scan(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Provenance_Attribute_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Provenance_Attribute_V1_QueryParamsRequest, Provenance_Attribute_V1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when handling 'attribute'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAttributeInterceptors() -> [ServerInterceptor<Provenance_Attribute_V1_QueryAttributeRequest, Provenance_Attribute_V1_QueryAttributeResponse>]

  /// - Returns: Interceptors to use when handling 'attributes'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAttributesInterceptors() -> [ServerInterceptor<Provenance_Attribute_V1_QueryAttributesRequest, Provenance_Attribute_V1_QueryAttributesResponse>]

  /// - Returns: Interceptors to use when handling 'scan'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeScanInterceptors() -> [ServerInterceptor<Provenance_Attribute_V1_QueryScanRequest, Provenance_Attribute_V1_QueryScanResponse>]
}
